diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/helper/wifi-helper.h ns-3.38/src/wifi/helper/wifi-helper.h
--- ns-3.37/src/wifi/helper/wifi-helper.h	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/helper/wifi-helper.h	2023-03-16 20:54:51.628957000 -0700
@@ -347,6 +347,21 @@
     void SetRemoteStationManager(std::string type, Args&&... args);
 
     /**
+     * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+     * \param linkId ID of the link to configure (>0 only for 11be devices)
+     * \param type the type of the preamble detection model to set.
+     * \param args A sequence of name-value pairs of the attributes to set.
+     *
+     * Set the remote station manager model and its attributes to use for the given link.
+     * If the helper stored a remote station manager model for the first N links only
+     * (corresponding to link IDs from 0 to N-1) and the given linkId is M >= N, then a
+     * remote station manager model using the given attributes is configured for all links
+     * with ID from N to M.
+     */
+    template <typename... Args>
+    void SetRemoteStationManager(uint8_t linkId, std::string type, Args&&... args);
+
+    /**
      * Helper function used to set the OBSS-PD algorithm
      *
      * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
@@ -503,15 +518,15 @@
     int64_t AssignStreams(NetDeviceContainer c, int64_t stream);
 
   protected:
-    ObjectFactory m_stationManager;            ///< station manager
-    WifiStandard m_standard;                   ///< wifi standard
-    ObjectFactory m_htConfig;                  ///< HT configuration
-    ObjectFactory m_vhtConfig;                 ///< VHT configuration
-    ObjectFactory m_heConfig;                  ///< HE configuration
-    ObjectFactory m_ehtConfig;                 ///< EHT configuration
-    SelectQueueCallback m_selectQueueCallback; ///< select queue callback
-    ObjectFactory m_obssPdAlgorithm;           ///< OBSS_PD algorithm
-    bool m_enableFlowControl;                  //!< whether to enable flow control
+    mutable std::vector<ObjectFactory> m_stationManager; ///< station manager
+    WifiStandard m_standard;                             ///< wifi standard
+    ObjectFactory m_htConfig;                            ///< HT configuration
+    ObjectFactory m_vhtConfig;                           ///< VHT configuration
+    ObjectFactory m_heConfig;                            ///< HE configuration
+    ObjectFactory m_ehtConfig;                           ///< EHT configuration
+    SelectQueueCallback m_selectQueueCallback;           ///< select queue callback
+    ObjectFactory m_obssPdAlgorithm;                     ///< OBSS_PD algorithm
+    bool m_enableFlowControl;                            //!< whether to enable flow control
 };
 
 } // namespace ns3
@@ -589,8 +604,21 @@
 void
 WifiHelper::SetRemoteStationManager(std::string type, Args&&... args)
 {
-    m_stationManager.SetTypeId(type);
-    m_stationManager.Set(args...);
+    SetRemoteStationManager(0, type, std::forward<Args>(args)...);
+}
+
+template <typename... Args>
+void
+WifiHelper::SetRemoteStationManager(uint8_t linkId, std::string type, Args&&... args)
+{
+    if (m_stationManager.size() > linkId)
+    {
+        m_stationManager[linkId] = ObjectFactory(type, std::forward<Args>(args)...);
+    }
+    else
+    {
+        m_stationManager.resize(linkId + 1, ObjectFactory(type, std::forward<Args>(args)...));
+    }
 }
 
 template <typename... Args>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ap-wifi-mac.cc ns-3.38/src/wifi/model/ap-wifi-mac.cc
--- ns-3.37/src/wifi/model/ap-wifi-mac.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/ap-wifi-mac.cc	2023-03-16 20:54:23.852869300 -0700
@@ -30,6 +30,7 @@
 #include "msdu-aggregator.h"
 #include "qos-txop.h"
 #include "reduced-neighbor-report.h"
+#include "wifi-mac-queue-scheduler.h"
 #include "wifi-mac-queue.h"
 #include "wifi-net-device.h"
 #include "wifi-phy.h"
@@ -341,28 +342,54 @@
         hdr.SetNoOrder(); // explicitly set to 0 for the time being since HT control field is not
                           // yet implemented (set it to 1 when implemented)
     }
-    hdr.SetAddr1(to);
-    hdr.SetAddr2(GetAddress());
-    hdr.SetAddr3(from);
-    hdr.SetDsFrom();
-    hdr.SetDsNotTo();
 
-    if (GetQosSupported())
+    std::list<Mac48Address> addr2Set;
+    if (to.IsGroup())
     {
-        // Sanity check that the TID is valid
-        NS_ASSERT(tid < 8);
-        GetQosTxop(tid)->Queue(packet, hdr);
+        // broadcast frames are transmitted on all the links
+        for (uint8_t linkId = 0; linkId < GetNLinks(); linkId++)
+        {
+            addr2Set.push_back(GetFrameExchangeManager(linkId)->GetAddress());
+        }
     }
     else
     {
-        GetTxop()->Queue(packet, hdr);
+        // the Transmitter Address (TA) is the MLD address only for non-broadcast data frames
+        // exchanged between two MLDs
+        addr2Set = {GetAddress()};
+        auto linkId = IsAssociated(to);
+        NS_ASSERT_MSG(linkId, "Station " << to << "is not associated, cannot send it a frame");
+        if (GetNLinks() == 1 || !GetWifiRemoteStationManager(*linkId)->GetMldAddress(to))
+        {
+            addr2Set = {GetFrameExchangeManager(*linkId)->GetAddress()};
+        }
+    }
+
+    for (const auto& addr2 : addr2Set)
+    {
+        hdr.SetAddr1(to);
+        hdr.SetAddr2(addr2);
+        hdr.SetAddr3(from);
+        hdr.SetDsFrom();
+        hdr.SetDsNotTo();
+
+        if (GetQosSupported())
+        {
+            // Sanity check that the TID is valid
+            NS_ASSERT(tid < 8);
+            GetQosTxop(tid)->Queue(packet, hdr);
+        }
+        else
+        {
+            GetTxop()->Queue(packet, hdr);
+        }
     }
 }
 
 bool
 ApWifiMac::CanForwardPacketsTo(Mac48Address to) const
 {
-    return (to.IsGroup() || GetWifiRemoteStationManager()->IsAssociated(to));
+    return (to.IsGroup() || IsAssociated(to));
 }
 
 void
@@ -796,7 +823,7 @@
     // segment that contains the primary channel.
     operation.SetChannelCenterFrequencySegment0(
         (bssBandwidth == 160)
-            ? phy->GetOperatingChannel().GetPrimaryChannelNumber(80, WIFI_STANDARD_80211ac)
+            ? phy->GetOperatingChannel().GetPrimaryChannelNumber(80, phy->GetStandard())
             : phy->GetChannelNumber());
     // For a 20, 40, or 80 MHz BSS bandwidth, this subfield is set to 0.
     // For a 160 MHz BSS bandwidth and the Channel Width subfield equal to 1,
@@ -855,6 +882,30 @@
     return operation;
 }
 
+EhtOperation
+ApWifiMac::GetEhtOperation(uint8_t linkId) const
+{
+    NS_LOG_FUNCTION(this << +linkId);
+    NS_ASSERT(GetEhtSupported());
+    EhtOperation operation;
+    auto remoteStationManager = GetWifiRemoteStationManager(linkId);
+
+    auto maxSpatialStream = GetWifiPhy(linkId)->GetMaxSupportedRxSpatialStreams();
+    for (const auto& sta : GetLink(linkId).staList)
+    {
+        if (remoteStationManager->GetEhtSupported(sta.second))
+        {
+            if (remoteStationManager->GetNumberOfSupportedStreams(sta.second) < maxSpatialStream)
+            {
+                maxSpatialStream = remoteStationManager->GetNumberOfSupportedStreams(sta.second);
+            }
+        }
+    }
+    operation.SetMaxRxNss(maxSpatialStream, 0, WIFI_EHT_MAX_MCS_INDEX);
+    operation.SetMaxTxNss(maxSpatialStream, 0, WIFI_EHT_MAX_MCS_INDEX);
+    return operation;
+}
+
 void
 ApWifiMac::SendProbeResp(Mac48Address to, uint8_t linkId)
 {
@@ -911,6 +962,7 @@
     if (GetEhtSupported())
     {
         probe.SetEhtCapabilities(GetEhtCapabilities(linkId));
+        probe.SetEhtOperation(GetEhtOperation(linkId));
 
         if (GetNLinks() > 1)
         {
@@ -1010,27 +1062,25 @@
     if (GetEhtSupported())
     {
         assoc.SetEhtCapabilities(GetEhtCapabilities(linkId));
+        assoc.SetEhtOperation(GetEhtOperation(linkId));
     }
     return assoc;
 }
 
-void
-ApWifiMac::SetAid(MgtAssocResponseHeader& assoc, const Mac48Address& to, uint8_t linkId)
+ApWifiMac::LinkIdStaAddrMap
+ApWifiMac::GetLinkIdStaAddrMap(MgtAssocResponseHeader& assoc,
+                               const Mac48Address& to,
+                               uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this << to << +linkId);
-
     // find all the links to setup (i.e., those for which status code is success)
-    std::list<std::reference_wrapper<MgtAssocResponseHeader>> assocResponses;
     std::map<uint8_t /* link ID */, Mac48Address> linkIdStaAddrMap;
 
     if (assoc.GetStatusCode().IsSuccess())
     {
-        assocResponses.push_back(std::ref(assoc));
         linkIdStaAddrMap[linkId] = to;
     }
 
-    const auto& mle = assoc.GetMultiLinkElement();
-    if (mle.has_value())
+    if (const auto& mle = assoc.GetMultiLinkElement())
     {
         const auto staMldAddress = GetWifiRemoteStationManager(linkId)->GetMldAddress(to);
         NS_ABORT_MSG_IF(!staMldAddress.has_value(),
@@ -1041,7 +1091,6 @@
             if (perStaProfile.HasAssocResponse() &&
                 perStaProfile.GetAssocResponse().GetStatusCode().IsSuccess())
             {
-                assocResponses.emplace_back(perStaProfile.GetAssocResponse());
                 uint8_t otherLinkId = perStaProfile.GetLinkId();
                 auto staAddress = GetWifiRemoteStationManager(otherLinkId)
                                       ->GetAffiliatedStaAddress(*staMldAddress);
@@ -1055,7 +1104,13 @@
         }
     }
 
-    if (assocResponses.empty())
+    return linkIdStaAddrMap;
+}
+
+void
+ApWifiMac::SetAid(MgtAssocResponseHeader& assoc, const LinkIdStaAddrMap& linkIdStaAddrMap)
+{
+    if (linkIdStaAddrMap.empty())
     {
         // no link to setup, nothing to do
         return;
@@ -1122,6 +1177,11 @@
         aid = GetNextAssociationId(linkIds);
     }
 
+    // store the MLD or link address in the AID-to-address map
+    const auto& [linkId, staAddr] = *linkIdStaAddrMap.cbegin();
+    m_aidToMldOrLinkAddress[aid] =
+        GetWifiRemoteStationManager(linkId)->GetMldAddress(staAddr).value_or(staAddr);
+
     for (const auto& [id, staAddr] : linkIdStaAddrMap)
     {
         auto remoteStationManager = GetWifiRemoteStationManager(id);
@@ -1162,9 +1222,21 @@
     // Element must not contain the AID field. We set the AID field in such
     // Association Responses anyway, in order to ease future implementation of
     // the inheritance mechanism.
-    for (auto& assocResp : assocResponses)
+    if (assoc.GetStatusCode().IsSuccess())
     {
-        assocResp.get().SetAssociationId(aid);
+        assoc.SetAssociationId(aid);
+    }
+    if (const auto& mle = assoc.GetMultiLinkElement())
+    {
+        for (std::size_t idx = 0; idx < mle->GetNPerStaProfileSubelements(); idx++)
+        {
+            if (const auto& perStaProfile = mle->GetPerStaProfile(idx);
+                perStaProfile.HasAssocResponse() &&
+                perStaProfile.GetAssocResponse().GetStatusCode().IsSuccess())
+            {
+                perStaProfile.GetAssocResponse().SetAssociationId(aid);
+            }
+        }
     }
 }
 
@@ -1194,7 +1266,13 @@
         assoc.SetMultiLinkElement(GetMultiLinkElement(linkId, hdr.GetType(), to));
     }
 
-    SetAid(assoc, to, linkId);
+    auto linkIdStaAddrMap = GetLinkIdStaAddrMap(assoc, to, linkId);
+    SetAid(assoc, linkIdStaAddrMap);
+
+    if (GetNLinks() > 1)
+    {
+        ConfigQueueScheduler(linkIdStaAddrMap, to, linkId);
+    }
 
     Ptr<Packet> packet = Create<Packet>();
     packet->AddHeader(assoc);
@@ -1221,6 +1299,39 @@
 }
 
 void
+ApWifiMac::ConfigQueueScheduler(const LinkIdStaAddrMap& linkIdStaAddrMap,
+                                const Mac48Address& to,
+                                uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << to << +linkId);
+
+    // get a list of the IDs of the links to setup
+    std::list<uint8_t> linkIds;
+    std::transform(linkIdStaAddrMap.cbegin(),
+                   linkIdStaAddrMap.cend(),
+                   std::back_inserter(linkIds),
+                   [](auto&& linkIdStaAddrPair) { return linkIdStaAddrPair.first; });
+
+    // get the MLD address of the STA, if affiliated with a non-AP MLD, or the STA address
+    auto staAddr = to;
+    if (auto mldAddr = GetWifiRemoteStationManager(linkId)->GetMldAddress(to))
+    {
+        staAddr = *mldAddr;
+    }
+
+    // configure the queue scheduler to only use the links that have been setup for
+    // transmissions to this station
+    for (const auto& [acIndex, wifiAc] : wifiAcList)
+    {
+        for (auto tid : {wifiAc.GetLowTid(), wifiAc.GetHighTid()})
+        {
+            WifiContainerQueueId queueId(WIFI_QOSDATA_UNICAST_QUEUE, staAddr, tid);
+            m_scheduler->SetLinkIds(acIndex, queueId, linkIds);
+        }
+    }
+}
+
+void
 ApWifiMac::SendOneBeacon(uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << +linkId);
@@ -1275,6 +1386,7 @@
     if (GetEhtSupported())
     {
         beacon.SetEhtCapabilities(GetEhtCapabilities(linkId));
+        beacon.SetEhtOperation(GetEhtOperation(linkId));
 
         if (GetNLinks() > 1)
         {
@@ -1402,21 +1514,59 @@
     }
 }
 
+std::optional<uint8_t>
+ApWifiMac::IsAssociated(const Mac48Address& address) const
+{
+    for (uint8_t linkId = 0; linkId < GetNLinks(); linkId++)
+    {
+        if (GetWifiRemoteStationManager(linkId)->IsAssociated(address))
+        {
+            return linkId;
+        }
+    }
+    NS_LOG_DEBUG(address << " is not associated");
+    return std::nullopt;
+}
+
+Mac48Address
+ApWifiMac::DoGetLocalAddress(const Mac48Address& remoteAddr) const
+{
+    auto linkId = IsAssociated(remoteAddr);
+    NS_ASSERT_MSG(linkId, remoteAddr << " is not associated");
+    return GetFrameExchangeManager(*linkId)->GetAddress();
+}
+
+std::optional<Mac48Address>
+ApWifiMac::GetMldOrLinkAddressByAid(uint16_t aid) const
+{
+    if (const auto staIt = m_aidToMldOrLinkAddress.find(aid);
+        staIt != m_aidToMldOrLinkAddress.cend())
+    {
+        return staIt->second;
+    }
+    return std::nullopt;
+}
+
 void
 ApWifiMac::Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << *mpdu << +linkId);
-    const WifiMacHeader* hdr = &mpdu->GetHeader();
+    // consider the MAC header of the original MPDU (makes a difference for data frames only)
+    const WifiMacHeader* hdr = &mpdu->GetOriginal()->GetHeader();
     Ptr<const Packet> packet = mpdu->GetPacket();
     Mac48Address from = hdr->GetAddr2();
     if (hdr->IsData())
     {
-        Mac48Address bssid = hdr->GetAddr1();
-        if (!hdr->IsFromDs() && hdr->IsToDs() && bssid == GetAddress() &&
-            GetWifiRemoteStationManager()->IsAssociated(from))
+        std::optional<uint8_t> apLinkId;
+        if (!hdr->IsFromDs() && hdr->IsToDs() &&
+            (apLinkId = IsAssociated(mpdu->GetHeader().GetAddr2())) &&
+            mpdu->GetHeader().GetAddr1() == GetFrameExchangeManager(*apLinkId)->GetAddress())
         {
             Mac48Address to = hdr->GetAddr3();
-            if (to == GetAddress())
+            // Address3 can be our MLD address (e.g., this is an MPDU containing a single MSDU
+            // addressed to us) or a BSSID (e.g., this is an MPDU containing an A-MSDU)
+            if (to == GetAddress() ||
+                (hdr->IsQosData() && hdr->IsQosAmsdu() && to == mpdu->GetHeader().GetAddr1()))
             {
                 NS_LOG_DEBUG("frame for me from=" << from);
                 if (hdr->IsQosData())
@@ -1430,15 +1580,15 @@
                     }
                     else
                     {
-                        ForwardUp(packet, from, bssid);
+                        ForwardUp(packet, from, GetAddress());
                     }
                 }
                 else if (hdr->HasData())
                 {
-                    ForwardUp(packet, from, bssid);
+                    ForwardUp(packet, from, GetAddress());
                 }
             }
-            else if (to.IsGroup() || GetWifiRemoteStationManager()->IsAssociated(to))
+            else if (to.IsGroup() || IsAssociated(to))
             {
                 NS_LOG_DEBUG("forwarding frame from=" << from << ", to=" << to);
                 Ptr<Packet> copy = packet->Copy();
@@ -1712,10 +1862,10 @@
         }
         if (GetEhtSupported())
         {
-            const auto& ehtCapabilities = frame.GetEhtCapabilities();
-            // TODO: once we support non constant rate managers, we should add checks here whether
-            // EHT is supported by the peer
-            remoteStationManager->AddStationEhtCapabilities(from, *ehtCapabilities);
+            if (const auto& ehtCapabilities = frame.GetEhtCapabilities())
+            {
+                remoteStationManager->AddStationEhtCapabilities(from, *ehtCapabilities);
+            }
             for (const auto& mcs : phy->GetMcsList(WIFI_MOD_CLASS_EHT))
             {
                 // TODO: Add check whether MCS is supported from the capabilities
@@ -1787,17 +1937,16 @@
     NS_LOG_FUNCTION(this << *mpdu);
     for (auto& i : *PeekPointer(mpdu))
     {
-        if (i.second.GetDestinationAddr() == GetAddress())
-        {
-            ForwardUp(i.first, i.second.GetSourceAddr(), i.second.GetDestinationAddr());
-        }
-        else
+        auto from = i.second.GetSourceAddr();
+        auto to = i.second.GetDestinationAddr();
+
+        if (to.IsGroup() || IsAssociated(to))
         {
-            Mac48Address from = i.second.GetSourceAddr();
-            Mac48Address to = i.second.GetDestinationAddr();
             NS_LOG_DEBUG("forwarding QoS frame from=" << from << ", to=" << to);
             ForwardDown(i.first->Copy(), from, to, mpdu->GetHeader().GetQosTid());
         }
+
+        ForwardUp(i.first, from, to);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ap-wifi-mac.h ns-3.38/src/wifi/model/ap-wifi-mac.h
--- ns-3.37/src/wifi/model/ap-wifi-mac.h	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/ap-wifi-mac.h	2023-03-16 20:54:23.852869300 -0700
@@ -42,6 +42,7 @@
 class HtOperation;
 class VhtOperation;
 class HeOperation;
+class EhtOperation;
 class CfParameterSet;
 class UniformRandomVariable;
 class MgtAssocRequestHeader;
@@ -107,7 +108,7 @@
      * \param linkId the ID of the given link
      * \return a const reference to the map of associated stations
      */
-    const std::map<uint16_t, Mac48Address>& GetStaList(uint8_t linkId = SINGLE_LINK_OP_ID) const;
+    const std::map<uint16_t, Mac48Address>& GetStaList(uint8_t linkId) const;
     /**
      * \param addr the address of the associated station
      * \param linkId the ID of the link on which the station is associated
@@ -116,6 +117,23 @@
     uint16_t GetAssociationId(Mac48Address addr, uint8_t linkId) const;
 
     /**
+     * Get the ID of a link (if any) that has been setup with the station having the given MAC
+     * address. The address can be either a link address or an MLD address. In the former case,
+     * the returned ID is the ID of the link connecting the AP to the STA with the given address.
+     *
+     * \param address the given MAC address
+     * \return the ID of a link (if any) that has been setup with the given station
+     */
+    std::optional<uint8_t> IsAssociated(const Mac48Address& address) const;
+
+    /**
+     * \param aid the given AID
+     * \return the MLD address (in case of MLD) or link address (in case of single link device)
+     *         of the STA having the given AID, if any
+     */
+    std::optional<Mac48Address> GetMldOrLinkAddressByAid(uint16_t aid) const;
+
+    /**
      * Return the value of the Queue Size subfield of the last QoS Data or QoS Null
      * frame received from the station with the given MAC address and belonging to
      * the given TID.
@@ -182,10 +200,15 @@
      */
     ApLinkEntity& GetLink(uint8_t linkId) const;
 
+    std::map<uint16_t, Mac48Address>
+        m_aidToMldOrLinkAddress; //!< Maps AIDs to MLD addresses (for MLDs) or link addresses (in
+                                 //!< case of single link devices)
+
   private:
     std::unique_ptr<LinkEntity> CreateLinkEntity() const override;
-
+    Mac48Address DoGetLocalAddress(const Mac48Address& remoteAddr) const override;
     void Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
+
     /**
      * Check whether the supported rate set included in the received (Re)Association
      * Request frame is compatible with our Basic Rate Set. If so, record all the station's
@@ -278,9 +301,10 @@
      * \return the Association Response frame
      */
     MgtAssocResponseHeader GetAssocResp(Mac48Address to, uint8_t linkId);
+    /// Map of (link ID, remote STA address) of the links to setup
+    using LinkIdStaAddrMap = std::map<uint8_t, Mac48Address>;
     /**
-     * Set the AID field of the given Association Response frame, which is going
-     * to be sent to the STA with the given address on the given link. In case of
+     * Set the AID field of the given Association Response frame. In case of
      * multi-link setup, the selected AID value must be assigned to all the STAs
      * corresponding to the setup links. The AID value is selected among the AID
      * values that are possibly already assigned to the STAs affiliated with the
@@ -288,10 +312,34 @@
      * a new AID value is selected.
      *
      * \param assoc the given Association Response frame
-     * \param to the address of the STA receiving the Association Response frame
-     * \param linkId the ID of the given link
+     * \param linkIdStaAddrMap a map of (link ID, remote STA address) of the links to setup
      */
-    void SetAid(MgtAssocResponseHeader& assoc, const Mac48Address& to, uint8_t linkId);
+    void SetAid(MgtAssocResponseHeader& assoc, const LinkIdStaAddrMap& linkIdStaAddrMap);
+    /**
+     * Get a map of (link ID, remote STA address) of the links to setup. Information
+     * is taken from the given Association Response that is sent over the given link
+     * to the given station.
+     *
+     * \param assoc the given Association Response frame
+     * \param to the Receiver Address (RA) of the Association Response frame
+     * \param linkId the ID of the link on which the Association Response frame is sent
+     * \return a map of (link ID, remote STA address) of the links to setup
+     */
+    LinkIdStaAddrMap GetLinkIdStaAddrMap(MgtAssocResponseHeader& assoc,
+                                         const Mac48Address& to,
+                                         uint8_t linkId);
+    /**
+     * Configure the queue scheduler so that frames stored in the container queues associated
+     * with the station which we are sending an Association Response frame to are only transmitted
+     * on the setup links.
+     *
+     * \param linkIdStaAddrMap a map of (link ID, remote STA address) of the links to setup
+     * \param to the Receiver Address (RA) of the Association Response frame
+     * \param linkId the ID of the link on which the Association Response frame is being sent
+     */
+    void ConfigQueueScheduler(const LinkIdStaAddrMap& linkIdStaAddrMap,
+                              const Mac48Address& to,
+                              uint8_t linkId);
     /**
      * Forward an association or a reassociation response packet to the DCF/EDCA.
      *
@@ -377,6 +425,13 @@
      */
     HeOperation GetHeOperation(uint8_t linkId) const;
     /**
+     * Return the EHT operation of the current AP for the given link.
+     *
+     * \param linkId the ID of the given link
+     * \return the EHT operation that we support
+     */
+    EhtOperation GetEhtOperation(uint8_t linkId) const;
+    /**
      * Return an instance of SupportedRates that contains all rates that we support
      * for the given link (including HT rates).
      *
@@ -448,14 +503,14 @@
     Time m_bsrLifetime;            //!< Lifetime of Buffer Status Reports
 
     /// store value and timestamp for each Buffer Status Report
-    typedef struct
+    struct BsrType
     {
         uint8_t value;  //!< value of BSR
         Time timestamp; //!< timestamp of BSR
-    } bsrType;
+    };
 
     /// Per (MAC address, TID) buffer status reports
-    std::unordered_map<WifiAddressTidPair, bsrType, WifiAddressTidHash> m_bufferStatus;
+    std::unordered_map<WifiAddressTidPair, BsrType, WifiAddressTidHash> m_bufferStatus;
 
     /**
      * TracedCallback signature for association/deassociation events.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/block-ack-agreement.h ns-3.38/src/wifi/model/block-ack-agreement.h
--- ns-3.37/src/wifi/model/block-ack-agreement.h	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/block-ack-agreement.h	2023-03-16 20:54:23.852869300 -0700
@@ -174,16 +174,16 @@
     static std::size_t GetDistance(uint16_t seqNumber, uint16_t startingSeqNumber);
 
   protected:
-    Mac48Address m_peer;       //!< Peer address
-    uint8_t m_amsduSupported;  //!< Flag whether MSDU aggregation is supported
-    uint8_t m_blockAckPolicy;  //!< Type of block ack: immediate or delayed
-    uint8_t m_tid;             //!< Traffic ID
-    uint16_t m_bufferSize;     //!< Buffer size
-    uint16_t m_timeout;        //!< Timeout
-    uint16_t m_startingSeq;    //!< Starting sequence control
-    uint16_t m_winEnd;         //!< Ending sequence number
-    uint8_t m_htSupported;     //!< Flag whether HT is supported
-    EventId m_inactivityEvent; //!< inactivity event
+    Mac48Address m_peer;               //!< Peer address
+    uint8_t m_amsduSupported;          //!< Flag whether MSDU aggregation is supported
+    uint8_t m_blockAckPolicy;          //!< Type of block ack: immediate or delayed
+    uint8_t m_tid;                     //!< Traffic ID
+    uint16_t m_bufferSize;             //!< Buffer size
+    uint16_t m_timeout;                //!< Timeout
+    uint16_t m_startingSeq;            //!< Starting sequence control
+    uint16_t m_winEnd;                 //!< Ending sequence number
+    uint8_t m_htSupported;             //!< Flag whether HT is supported
+    mutable EventId m_inactivityEvent; //!< inactivity event
 };
 
 } // namespace ns3
